#! /bin/sh

set -e 

command=${COMMAND:-debug mem; run; quit}
mgsim=${MGSIM:-mipsel-mgsim}
baseini=${BASECONFIG:-minisim33.ini}

mkdir -p output

for l1c in l1_*.ini; do
  for m in mem_*.ini; do
      case $m in
          *l2*)
              for l2c in l2_*.ini; do
                  printf "${l1c%.ini}"'\t'"${m%.ini}"'\t'"${l2c%.ini}"'\t'
                  echo "$command" | \
                      $mgsim -i -c "$baseini" -I "$l1c" -I "$m" -I "$l2c" "$@" 2>&1 | \
                      tee "output/${l1c%.ini}.${m%.ini}.${l2c%.ini}.log" | \
                      grep "# core cycle" | cut -d'#' -f1
              done
              ;;
          *)
              printf "${l1c%.ini}"'\t'"${m%.ini}"'\t'
              echo "$command" | \
                  $mgsim -i -c "$baseini" -I "$l1c" -I "$m" "$@" 2>&1 | \
                  tee "output/${l1c%.ini}.${m%.ini}.log" | \
                  grep "# core cycle" | cut -d'#' -f1
              ;;
      esac
  done
done
